/**
 * Copyright (c) 2014-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.registry.overlay.api;

import javax.xml.namespace.QName;

import org.ow2.petals.microkernel.api.communication.sharedarea.SharedAreaService;
import org.ow2.petals.microkernel.api.communication.sharedarea.exception.SharedAreaException;
import org.w3c.dom.Document;

/**
 * The dedicated API of the Registry Overlay Client
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public interface RegistryOverlayAPI extends SharedAreaService {

    /**
     * Names of properties contained into the configuration returned by
     * {@link EndpointRegistry#getConfiguration(String, String)}
     * 
     * @author Christophe DENEUX - Linagora
     * 
     */
    public static class RegistryItem {

        /**
         * Registry Overlay key name: group name
         */
        public static final String GROUP_NAME = "group-name";

        /**
         * Registry Overlay key name: group password
         */
        public static final String GROUP_PASSWORD = "group-password";

        /**
         * Registry Overlay key name: cluster member address
         */
        public static final String ADDRESS = "address";
    }
    
    /**
     * Retrieve the description of the given endpoint as a {@link Document}.
     */
    public Document retrieveEndpointDescription(QName serviceName, String endpointName) throws SharedAreaException;

}
